# -------------------------------
# 	LPS Example
#
# 	Routine 2
#
#	Language: MIPS32-MARS
#	Style: plain MIPS32
# 	Version: LPS20-L19-mips
# -------------------------------

#  Lecture L19 Plain MIPS32 Solution

# Questo esempio viene usato per mostrare come realizzare
# una routine foglia che accetta parametri e restituisce un risultato;
# parametri e risultato vengono comunicati usando dei registri

# In particolare si mostra la traduzione di una funzione C che
# prende in ingresso due valori di tipo int b ed n e, 
# assumendo che sia n >= 0, calcola b^n.

# Questo esempio e' realizzato per l'assembler MARS
# Per eseguire il programma si possono usare i comandi della GUI

# Variabili
# il tipo int viene memorizzato con word
	.data
k:	.word	0

# Programma
	.text

inizio_codice:

# Routine main
main:

#		k = power( 3, 2 );
	li	$t0,3
	li	$t1,2
	jal	power
	sw	$t2,k

#		k = power( k, 3 );
	lw	$t0,k
	li	$t1,3
	jal	power
	sw	$t2,k

#		k = power( 2, 12 );
	li	$t0,2
	li	$t1,12
	jal	power
	sw	$t2,k

fine_main:

	# fine programma
	j	fine_codice

# Routine power
# Input
# 	t0 - parametro b
#	t1 - parametro n
# Output
#	t2 - risultato
# Registri modificati
#	t2 - risultato, variabile c
#	t3 - variabile i
power:
	move	$t3,$zero
	li	$t2,1
pow_while_beg:
	bge	$t3,$t1,pow_while_end
	mul	$t2,$t2,$t0
	add	$t3,$t3,1
	b	pow_while_beg

pow_while_end:
	jr	$ra

fine_codice:

# Original Plain C Code
#
# int power( int b, int n ) {
#	int i = 0, c = 1;
#	while ( i < n ) {
#		c = c * b;
#		i++;
#	}
#	return c;
# }
#
# int main( void ) {
#	int k;
#	k = power( 3, 2 );
#	k = power( k, 3 );
#	k = power( 2, 12 );
#	return 0;
# }
